diff --git a/django/apps/__init__.py b/django/apps/__init__.py
new file mode 100644
index 0000000..ca60d0c
--- /dev/null
+++ b/django/apps/__init__.py
@@ -0,0 +1,22 @@
+from django.apps.base import App
+from django.apps.cache import AppCache
+
+__all__ = (
+    'App', 'find_app', 'get_apps', 'get_app', 'get_app_errors',
+    'get_models', 'get_model', 'register_models', 'load_app',
+    'app_cache_ready'
+)
+
+cache = AppCache()
+
+# These methods were always module level, so are kept that way for backwards
+# compatibility.
+find_app = cache.find_app
+get_apps = cache.get_apps
+get_app = cache.get_app
+get_app_errors = cache.get_app_errors
+get_models = cache.get_models
+get_model = cache.get_model
+register_models = cache.register_models
+load_app = cache.load_app
+app_cache_ready = cache.app_cache_ready
diff --git a/django/apps/base.py b/django/apps/base.py
new file mode 100644
index 0000000..21990bb
--- /dev/null
+++ b/django/apps/base.py
@@ -0,0 +1,64 @@
+import re
+import sys
+
+from django.apps.options import AppOptions, DEFAULT_NAMES
+
+module_name_re = re.compile(r'_([a-z])')
+
+
+class AppBase(type):
+    """
+    Metaclass for all apps.
+    """
+    def __new__(cls, name, bases, attrs):
+        super_new = super(AppBase, cls).__new__
+        parents = [b for b in bases if isinstance(b, AppBase)]
+        if not parents:
+            # If this isn't a subclass of App, don't do anything special.
+            return super_new(cls, name, bases, attrs)
+        module = attrs.pop('__module__', None)
+        new_class = super_new(cls, name, bases, {'__module__': module})
+        attr_meta = attrs.pop('Meta', None)
+        if not attr_meta:
+            meta = getattr(new_class, 'Meta', None)
+        else:
+            meta = attr_meta
+        app_name = attrs.pop('_name', None)
+        if app_name is None:
+            # Figure out the app_name by looking one level up.
+            # For 'django.contrib.sites.app', this would be 'django.contrib.sites'
+            app_module = sys.modules[new_class.__module__]
+            app_name = app_module.__name__.rsplit('.', 1)[0]
+        new_class.add_to_class('_meta', AppOptions(app_name, meta))
+        # For easier Meta inheritance
+        new_class.add_to_class('Meta', attr_meta)
+        return new_class
+
+    def add_to_class(cls, name, value):
+        if hasattr(value, 'contribute_to_class'):
+            value.contribute_to_class(cls, name)
+        else:
+            setattr(cls, name, value)
+
+
+class App(object):
+    """
+    The base app class to be subclassed for own uses.
+    """
+    __metaclass__ = AppBase
+
+    def __init__(self, **options):
+        for key, value in options.iteritems():
+            if key in DEFAULT_NAMES:
+                setattr(self._meta, key, value)
+            else:
+                setattr(self, key, value)
+
+    def __repr__(self):
+        return '<App: %s>' % self._meta.name
+
+    @classmethod
+    def from_name(cls, name):
+        upper = lambda match: match.group(1).upper()
+        cls_name = module_name_re.sub(upper, name.split('.')[-1])
+        return type(cls_name[0].upper()+cls_name[1:], (cls,), {'_name': name})
diff --git a/django/apps/cache.py b/django/apps/cache.py
new file mode 100644
index 0000000..4973e74
--- /dev/null
+++ b/django/apps/cache.py
@@ -0,0 +1,351 @@
+import sys
+import os
+import threading
+
+from django.conf import settings
+from django.core.exceptions import ImproperlyConfigured
+from django.utils.datastructures import SortedDict
+from django.utils.importlib import import_module
+from django.utils.module_loading import module_has_submodule
+
+from django.apps.base import App
+from django.apps.signals import app_loaded, post_apps_loaded
+
+
+def _initialize():
+    """
+    Returns a dictionary to be used as the initial value of the
+    shared state of the app cache.
+    """
+    return {
+        # list of loaded app instances
+        'loaded_apps': [],
+
+        # Mapping of app_labels to a dictionary of model names to model code.
+        'app_models': SortedDict(),
+
+        # -- Everything below here is only used when populating the cache --
+        'loaded': False,
+        'handled': [],
+        'postponed': [],
+        'nesting_level': 0,
+        '_get_models_cache': {},
+    }
+
+
+class AppCache(object):
+    """
+    A cache that stores installed applications and their models. Used to
+    provide reverse-relations and for app introspection (e.g. admin).
+    """
+    # Use the Borg pattern to share state between all instances. Details at
+    # http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/66531.
+    __shared_state = dict(_initialize(), write_lock=threading.RLock())
+
+    def __init__(self):
+        self.__dict__ = self.__shared_state
+
+    def _reset(self):
+        """
+        Resets the cache to its initial (unseeded) state
+        """
+        # remove imported model modules, so ModelBase.__new__ can register
+        # them with the cache again
+        for app, models in self.app_models.iteritems():
+            for model in models.itervalues():
+                module = model.__module__
+                if module in sys.modules:
+                    del sys.modules[module]
+        self.__class__.__shared_state.update(_initialize())
+
+    def _reload(self):
+        """
+        Reloads the cache
+        """
+        self._reset()
+        self._populate()
+
+    def _populate(self):
+        """
+        Fill in all the cache information. This method is threadsafe, in the
+        sense that every caller will see the same state upon return, and if the
+        cache is already initialised, it does no work.
+        """
+        if self.loaded:
+            return
+        self.write_lock.acquire()
+        try:
+            if self.loaded:
+                return
+            for app_name in settings.INSTALLED_APPS:
+                if isinstance(app_name, (tuple, list)):
+                    app_name, app_kwargs = app_name
+                else:
+                    app_kwargs = {}
+                if app_name in self.handled:
+                    continue
+                self.load_app(app_name, app_kwargs, True)
+            if not self.nesting_level:
+                for app_name, app_kwargs in self.postponed:
+                    self.load_app(app_name, app_kwargs)
+                # assign models to app instances
+                for app in self.loaded_apps:
+                    parents = [p for p in app.__class__.mro()
+                               if hasattr(p, '_meta')]
+                    for parent in reversed(parents):
+                        parent_models = self.app_models.get(parent._meta.label, {})
+                        # update app_label and installed attribute of parent models
+                        for model in parent_models.itervalues():
+                            model._meta.app_label = app._meta.label
+                            model._meta.installed = True
+                        app._meta.models.update(parent_models)
+
+                # check if there is more than one app with the same
+                # db_prefix attribute
+                for app1 in self.loaded_apps:
+                    for app2 in self.loaded_apps:
+                        if (app1 != app2 and
+                                app1._meta.db_prefix == app2._meta.db_prefix):
+                            raise ImproperlyConfigured(
+                                'The apps "%s" and "%s" have the same db_prefix "%s"'
+                                % (app1, app2, app1._meta.db_prefix))
+                self.loaded = True
+                # send the post_apps_loaded signal
+                post_apps_loaded.send(sender=self, apps=self.loaded_apps)
+        finally:
+            self.write_lock.release()
+
+    def get_app_class(self, app_name):
+        """
+        Returns an app class for the given app name, which can be a
+        dotted path to an app class or a dotted app module path.
+        """
+        try:
+            app_path, app_attr = app_name.rsplit('.', 1)
+        except ValueError:
+            # First, return a new app class for the given module if
+            # it's one level module path that can't be rsplit (e.g. 'myapp')
+            return App.from_name(app_name)
+        try:
+            # Secondly, try to import the module directly,
+            # because it'll fail with a class path or a bad path
+            app_module = import_module(app_path)
+        except ImportError, e:
+            raise ImproperlyConfigured(
+                "Could not import app '%s': %s" % (app_path, e))
+        else:
+            # Thirdly, check if there is the submodule and fall back if yes
+            # If not look for the app class and do some type checks
+            if not module_has_submodule(app_module, app_attr):
+                try:
+                    app_class = getattr(app_module, app_attr)
+                except AttributeError:
+                    raise ImproperlyConfigured(
+                        "Could not find app '%s' in "
+                        "module '%s'" % (app_attr, app_path))
+                else:
+                    if not issubclass(app_class, App):
+                        raise ImproperlyConfigured(
+                            "App '%s' must be a subclass of "
+                            "'django.apps.App'" % app_name)
+                    return app_class
+        return App.from_name(app_name)
+
+    def load_app(self, app_name, app_kwargs=None, can_postpone=False):
+        """
+        Loads the app with the provided fully qualified name, and returns the
+        model module.
+
+        Keyword Arguments:
+            app_name: fully qualified name (e.g. 'django.contrib.auth')
+            can_postpone: If set to True and the import raises an ImportError
+                the loading will be postponed and tried again when all other
+                modules are loaded.
+        """
+        if app_kwargs is None:
+            app_kwargs = {}
+
+        self.handled.append(app_name)
+        self.nesting_level += 1
+
+        # check if an app instance with app_name already exists, if not
+        # then create one
+        app = self.find_app(app_name.split('.')[-1])
+        if not app:
+            app_class = self.get_app_class(app_name)
+            app = app_class(**app_kwargs)
+            self.loaded_apps.append(app)
+            # Send the signal that the app has been loaded
+            app_loaded.send(sender=app_class, app=app)
+
+        # import the app's models module and handle ImportErrors
+        try:
+            models = import_module(app._meta.models_path)
+        except ImportError:
+            self.nesting_level -= 1
+            # If the app doesn't have a models module, we can just ignore the
+            # ImportError and return no models for it.
+            if not module_has_submodule(app._meta.module, 'models'):
+                return None
+            # But if the app does have a models module, we need to figure out
+            # whether to suppress or propagate the error. If can_postpone is
+            # True then it may be that the package is still being imported by
+            # Python and the models module isn't available yet. So we add the
+            # app to the postponed list and we'll try it again after all the
+            # recursion has finished (in populate). If can_postpone is False
+            # then it's time to raise the ImportError.
+            else:
+                if can_postpone:
+                    self.postponed.append((app_name, app_kwargs))
+                    return None
+                else:
+                    raise
+
+        self.nesting_level -= 1
+        app._meta.models_module = models
+        return models
+
+    def find_app(self, app_label):
+        """
+        Returns the app instance that matches the given label.
+        """
+        for app in self.loaded_apps:
+            if app._meta.label == app_label:
+                return app
+
+    def find_app_by_models_module(self, models_module):
+        """
+        Returns the app instance that matches the models module
+        """
+        for app in self.loaded_apps:
+            if app._meta.models_module == models_module:
+                return app
+
+    def app_cache_ready(self):
+        """
+        Returns true if the model cache is fully populated.
+
+        Useful for code that wants to cache the results of get_models() for
+        themselves once it is safe to do so.
+        """
+        return self.loaded
+
+    def get_apps(self):
+        """
+        Returns a list of all models modules.
+        """
+        self._populate()
+        return [app._meta.models_module for app in self.loaded_apps
+                if app._meta.models_module]
+
+    def get_app(self, app_label, emptyOK=False):
+        """
+        Returns the module containing the models for the given app_label. If
+        the app has no models in it and 'emptyOK' is True, returns None.
+        """
+        self._populate()
+        app = self.find_app(app_label)
+        if app:
+            mod = app._meta.models_module
+            if mod is None:
+                if emptyOK:
+                    return None
+            else:
+                return mod
+        raise ImproperlyConfigured(
+                "App with label %s could not be found" % app_label)
+
+    def get_app_errors(self):
+        """
+        Returns the map of known problems with the INSTALLED_APPS.
+        """
+        self._populate()
+        errors = {}
+        for app in self.loaded_apps:
+            if app._meta.errors:
+                errors.update({app._meta.label: app._meta.errors})
+        return errors
+
+    def get_models(self, app_mod=None,
+                   include_auto_created=False, include_deferred=False,
+                   only_installed=True):
+        """
+        Given a module containing models, returns a list of the models.
+        Otherwise returns a list of all installed models.
+
+        By default, auto-created models (i.e., m2m models without an
+        explicit intermediate table) are not included. However, if you
+        specify include_auto_created=True, they will be.
+
+        By default, models created to satisfy deferred attribute
+        queries are *not* included in the list of models. However, if
+        you specify include_deferred, they will be.
+        """
+        cache_key = (app_mod, include_auto_created, include_deferred,
+                     only_installed)
+        try:
+            return self._get_models_cache[cache_key]
+        except KeyError:
+            pass
+        self._populate()
+        app_list = []
+        if app_mod and only_installed:
+            app_label = app_mod.__name__.split('.')[-2]
+            app = self.find_app(app_label)
+            if app:
+                app_list = [app._meta.models]
+        else:
+            if only_installed:
+                app_list = [app._meta.models for app in self.loaded_apps]
+            else:
+                app_list = self.app_models.itervalues()
+        model_list = []
+        for app in app_list:
+            model_list.extend(
+                model for model in app.values()
+                if ((not model._deferred or include_deferred) and
+                    (not model._meta.auto_created or include_auto_created))
+            )
+        self._get_models_cache[cache_key] = model_list
+        return model_list
+
+    def get_model(self, app_label, model_name,
+                  seed_cache=True, only_installed=True):
+        """
+        Returns the model matching the given app_label and case-insensitive
+        model_name.
+
+        Returns None if no model is found.
+        """
+        if seed_cache:
+            self._populate()
+        if only_installed:
+            app = self.find_app(app_label)
+            if not app:
+                return
+            return app._meta.models.get(model_name.lower())
+        return self.app_models.get(app_label, SortedDict()).get(model_name.lower())
+
+    def register_models(self, app_label, *models):
+        """
+        Register a set of models as belonging to an app.
+        """
+        app = self.find_app(app_label)
+        for model in models:
+            model_name = model._meta.object_name.lower()
+            model_dict = self.app_models.setdefault(app_label, SortedDict())
+            if model_name in model_dict:
+                # The same model may be imported via different paths (e.g.
+                # appname.models and project.appname.models). We use the source
+                # filename as a means to detect identity.
+                fname1 = os.path.abspath(sys.modules[model.__module__].__file__)
+                fname2 = os.path.abspath(sys.modules[model_dict[model_name].__module__].__file__)
+                # Since the filename extension could be .py the first time and
+                # .pyc or .pyo the second time, ignore the extension when
+                # comparing.
+                if os.path.splitext(fname1)[0] == os.path.splitext(fname2)[0]:
+                    continue
+            if app:
+                app._meta.models[model_name] = model
+            model_dict[model_name] = model
+        self._get_models_cache.clear()
diff --git a/django/apps/options.py b/django/apps/options.py
new file mode 100644
index 0000000..7a71552
--- /dev/null
+++ b/django/apps/options.py
@@ -0,0 +1,50 @@
+import re
+import os
+
+from django.utils.datastructures import SortedDict
+from django.utils.importlib import import_module
+from django.utils.text import get_verbose_name
+
+DEFAULT_NAMES = ('verbose_name', 'db_prefix', 'models_path')
+
+
+class AppOptions(object):
+    def __init__(self, name, meta):
+        self.name = name
+        self.meta = meta
+        self.errors = []
+        self.models = SortedDict()
+
+    def contribute_to_class(self, cls, name):
+        cls._meta = self
+        # get the name from the path e.g. "auth" for "django.contrib.auth"
+        self.label = self.name.split('.')[-1]
+        self.models_module = None
+        self.module = import_module(self.name)
+        self.path = os.path.dirname(self.module.__file__)
+        defaults = {
+            'db_prefix': self.label,
+            'models_path': '%s.models' % self.name,
+            'verbose_name': get_verbose_name(self.label),
+        }
+        # Next, apply any overridden values from 'class Meta'.
+        if self.meta:
+            meta_attrs = self.meta.__dict__.copy()
+            for name in self.meta.__dict__:
+                # Ignore any private attributes that Django doesn't care about.
+                if name.startswith('_'):
+                    del meta_attrs[name]
+            for attr_name in DEFAULT_NAMES:
+                if attr_name in meta_attrs:
+                    setattr(self, attr_name, meta_attrs.pop(attr_name))
+                elif hasattr(self.meta, attr_name):
+                    setattr(self, attr_name, getattr(self.meta, attr_name))
+            # Any leftover attributes must be invalid.
+            if meta_attrs != {}:
+                raise TypeError("'class Meta' got invalid attribute(s): %s"
+                                % ','.join(meta_attrs.keys()))
+        del self.meta
+
+        for k, v in defaults.iteritems():
+            if not hasattr(self, k):
+                setattr(self, k, v)
diff --git a/django/apps/signals.py b/django/apps/signals.py
new file mode 100644
index 0000000..befb77c
--- /dev/null
+++ b/django/apps/signals.py
@@ -0,0 +1,7 @@
+from django.dispatch import Signal
+
+# Sent when an app is loaded by the app cache
+app_loaded = Signal(providing_args=["app"])
+
+# Sent when the app cache loads the apps
+post_apps_loaded = Signal(providing_args=["apps"])
diff --git a/django/contrib/admin/__init__.py b/django/contrib/admin/__init__.py
index 1084784..0507223 100644
--- a/django/contrib/admin/__init__.py
+++ b/django/contrib/admin/__init__.py
@@ -1,5 +1,6 @@
 # ACTION_CHECKBOX_NAME is unused, but should stay since its import from here
 # has been referenced in documentation.
+from django.apps import cache
 from django.contrib.admin.helpers import ACTION_CHECKBOX_NAME
 from django.contrib.admin.options import ModelAdmin, HORIZONTAL, VERTICAL
 from django.contrib.admin.options import StackedInline, TabularInline
@@ -8,7 +9,6 @@ from django.contrib.admin.filters import (ListFilter, SimpleListFilter,
     FieldListFilter, BooleanFieldListFilter, RelatedFieldListFilter,
     ChoicesFieldListFilter, DateFieldListFilter, AllValuesFieldListFilter)
 
-
 def autodiscover():
     """
     Auto-discover INSTALLED_APPS admin.py modules and fail silently when
@@ -21,12 +21,11 @@ def autodiscover():
     from django.utils.importlib import import_module
     from django.utils.module_loading import module_has_submodule
 
-    for app in settings.INSTALLED_APPS:
-        mod = import_module(app)
+    for app in cache.loaded_apps:
         # Attempt to import the app's admin module.
         try:
             before_import_registry = copy.copy(site._registry)
-            import_module('%s.admin' % app)
+            import_module('%s.admin' % app._meta.name)
         except:
             # Reset the model registry to the state before the last import as
             # this import will have to reoccur on the next request and this
@@ -37,5 +36,5 @@ def autodiscover():
             # Decide whether to bubble up this error. If the app just
             # doesn't have an admin module, we can ignore the error
             # attempting to import it, otherwise we want it to bubble up.
-            if module_has_submodule(mod, 'admin'):
+            if module_has_submodule(app._meta.module, 'admin'):
                 raise
diff --git a/django/contrib/admin/options.py b/django/contrib/admin/options.py
index cf7ea83..6a0f5dd 100644
--- a/django/contrib/admin/options.py
+++ b/django/contrib/admin/options.py
@@ -1,5 +1,5 @@
 from functools import update_wrapper, partial
-from django import forms
+from django import apps, forms, template
 from django.forms.formsets import all_valid
 from django.forms.models import (modelform_factory, modelformset_factory,
     inlineformset_factory, BaseInlineFormSet)
@@ -968,7 +968,7 @@ class ModelAdmin(BaseModelAdmin):
             'media': mark_safe(media),
             'inline_admin_formsets': inline_admin_formsets,
             'errors': helpers.AdminErrorList(form, formsets),
-            'app_label': opts.app_label,
+            'app_label': apps.find_app(opts.app_label)._meta.verbose_name,
         }
         context.update(extra_context or {})
         return self.render_change_form(request, context, form_url=form_url, add=True)
@@ -1058,7 +1058,7 @@ class ModelAdmin(BaseModelAdmin):
             'media': mark_safe(media),
             'inline_admin_formsets': inline_admin_formsets,
             'errors': helpers.AdminErrorList(form, formsets),
-            'app_label': opts.app_label,
+            'app_label': apps.find_app(opts.app_label)._meta.verbose_name,
         }
         context.update(extra_context or {})
         return self.render_change_form(request, context, change=True, obj=obj)
@@ -1199,7 +1199,7 @@ class ModelAdmin(BaseModelAdmin):
             'cl': cl,
             'media': media,
             'has_add_permission': self.has_add_permission(request),
-            'app_label': app_label,
+            'app_label': apps.find_app(app_label)._meta.verbose_name,
             'action_form': action_form,
             'actions_on_top': self.actions_on_top,
             'actions_on_bottom': self.actions_on_bottom,
@@ -1263,7 +1263,7 @@ class ModelAdmin(BaseModelAdmin):
             "perms_lacking": perms_needed,
             "protected": protected,
             "opts": opts,
-            "app_label": app_label,
+            "app_label": apps.find_app(app_label)._meta.verbose_name,
         }
         context.update(extra_context or {})
 
@@ -1290,7 +1290,7 @@ class ModelAdmin(BaseModelAdmin):
             'action_list': action_list,
             'module_name': capfirst(force_unicode(opts.verbose_name_plural)),
             'object': obj,
-            'app_label': app_label,
+            'app_label': apps.find_app(app_label)._meta.verbose_name,
         }
         context.update(extra_context or {})
         return TemplateResponse(request, self.object_history_template or [
diff --git a/django/contrib/admin/sites.py b/django/contrib/admin/sites.py
index 49c1e78..92b4478 100644
--- a/django/contrib/admin/sites.py
+++ b/django/contrib/admin/sites.py
@@ -1,5 +1,6 @@
 from functools import update_wrapper
-from django import http
+
+from django import apps, http
 from django.contrib.admin import ModelAdmin, actions
 from django.contrib.admin.forms import AdminAuthenticationForm
 from django.contrib.auth import REDIRECT_FIELD_NAME
@@ -348,7 +349,7 @@ class AdminSite(object):
                         app_dict[app_label]['models'].append(model_dict)
                     else:
                         app_dict[app_label] = {
-                            'name': app_label.title(),
+                            'name': apps.find_app(app_label)._meta.verbose_name,
                             'app_url': app_label + '/',
                             'has_module_perms': has_module_perms,
                             'models': [model_dict],
@@ -375,6 +376,7 @@ class AdminSite(object):
         user = request.user
         has_module_perms = user.has_module_perms(app_label)
         app_dict = {}
+        app = apps.find_app(app_label)
         for model, model_admin in self._registry.items():
             if app_label == model._meta.app_label:
                 if has_module_perms:
@@ -395,7 +397,7 @@ class AdminSite(object):
                             # something to display, add in the necessary meta
                             # information.
                             app_dict = {
-                                'name': app_label.title(),
+                                'name': app._meta.verbose_name,
                                 'app_url': '',
                                 'has_module_perms': has_module_perms,
                                 'models': [model_dict],
@@ -405,7 +407,7 @@ class AdminSite(object):
         # Sort the models alphabetically within each app.
         app_dict['models'].sort(key=lambda x: x['name'])
         context = {
-            'title': _('%s administration') % capfirst(app_label),
+            'title': _('%s administration') % app._meta.verbose_name,
             'app_list': [app_dict],
         }
         context.update(extra_context or {})
diff --git a/django/contrib/auth/app.py b/django/contrib/auth/app.py
new file mode 100644
index 0000000..159b713
--- /dev/null
+++ b/django/contrib/auth/app.py
@@ -0,0 +1,7 @@
+from django import apps
+from django.utils.translation import ugettext_lazy as _
+
+class AuthApp(apps.App):
+
+    class Meta:
+        verbose_name = _('auth')
diff --git a/django/contrib/contenttypes/management.py b/django/contrib/contenttypes/management.py
index 27d1275..a444714 100644
--- a/django/contrib/contenttypes/management.py
+++ b/django/contrib/contenttypes/management.py
@@ -1,5 +1,6 @@
+from django.apps import cache, get_apps, get_models
 from django.contrib.contenttypes.models import ContentType
-from django.db.models import get_apps, get_models, signals
+from django.db.models import signals
 from django.utils.encoding import smart_unicode
 
 def update_contenttypes(app, created_models, verbosity=2, **kwargs):
@@ -7,8 +8,9 @@ def update_contenttypes(app, created_models, verbosity=2, **kwargs):
     Creates content types for models in the given app, removing any model
     entries that no longer have a matching model class.
     """
+    app_cls = cache.find_app_by_models_module(app)
     ContentType.objects.clear_cache()
-    content_types = list(ContentType.objects.filter(app_label=app.__name__.split('.')[-2]))
+    content_types = list(ContentType.objects.filter(app_label=app_cls._meta.label))
     app_models = get_models(app)
     if not app_models:
         return
diff --git a/django/contrib/staticfiles/finders.py b/django/contrib/staticfiles/finders.py
index 45bf4a1..b23428b 100644
--- a/django/contrib/staticfiles/finders.py
+++ b/django/contrib/staticfiles/finders.py
@@ -1,4 +1,5 @@
 import os
+from django.apps import cache
 from django.conf import settings
 from django.core.exceptions import ImproperlyConfigured
 from django.core.files.storage import default_storage, Storage, FileSystemStorage
@@ -113,14 +114,12 @@ class AppDirectoriesFinder(BaseFinder):
     """
     storage_class = AppStaticStorage
 
-    def __init__(self, apps=None, *args, **kwargs):
+    def __init__(self, *args, **kwargs):
         # The list of apps that are handled
         self.apps = []
         # Mapping of app module paths to storage instances
         self.storages = SortedDict()
-        if apps is None:
-            apps = settings.INSTALLED_APPS
-        for app in apps:
+        for app in cache.loaded_apps:
             app_storage = self.storage_class(app)
             if os.path.isdir(app_storage.location):
                 self.storages[app] = app_storage
diff --git a/django/contrib/staticfiles/storage.py b/django/contrib/staticfiles/storage.py
index a804c56..ef04f20 100644
--- a/django/contrib/staticfiles/storage.py
+++ b/django/contrib/staticfiles/storage.py
@@ -194,9 +194,7 @@ class AppStaticStorage(FileSystemStorage):
         Returns a static file storage if available in the given app.
         """
         # app is the actual app module
-        mod = import_module(app)
-        mod_path = os.path.dirname(mod.__file__)
-        location = os.path.join(mod_path, self.source_dir)
+        location = os.path.join(app._meta.path, self.source_dir)
         super(AppStaticStorage, self).__init__(location, *args, **kwargs)
 
 
